%define anolis_release 1
%define debug_package %{nil}
%global github_source_archive_name   ippcp_2021.7

Name:               intel-ipp-crypto-mb
Summary:            Intel(R) IPP Cryptography multi-buffer library
Release:            %{anolis_release}%{?dist}
Version:            1.0.6
License:            Apache-2.0
# Upstream exclusively uses x86_64-specific intrinsics
ExclusiveArch:      x86_64
URL:                https://github.com/intel/ipp-crypto
Source0:	    https://github.com/intel/ipp-crypto/archive/refs/tags/%{github_source_archive_name}.tar.gz

BuildRequires: 	    cmake
BuildRequires:	    gcc
BuildRequires:	    gcc-c++
BuildRequires:	    openssl-devel >= 1.1.0

%description
A software crypto library optimized for Intel architecture for packet
processing applications.
It contains universal and OpenSSL compatible APIs for cryptography operations.

%package devel
Summary:            Intel(R) IPP Cryptography multi-buffer library (Development Files)
Requires:           %{name} = %{version}-%{release}
ExclusiveArch:      x86_64

%description devel
A software crypto library optimized for Intel architecture for packet
processing applications.
It contains development libraries and header files.

%package static
Summary: 	Intel(R) IPP Cryptography multi-buffer library (Development Files)
Requires:	%{name} = %{version}-%{release}

%description static 
Static file for %{name}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n ipp-crypto-%{github_source_archive_name} -p1
sed -i 's/"lib\"/"lib64"/g' sources/ippcp/crypto_mb/src/CMakeLists.txt

%build
pushd sources/ippcp/crypto_mb
%cmake \
	-DARCH=intel64 \
	-DMERGED_BLD:BOOL=off
%cmake_build
popd

%install
pushd sources/ippcp/crypto_mb
%cmake_install

install -p -s -m 0755 %{__cmake_builddir}/bin/libcrypto_mb.so.11.5 %{buildroot}/%{_libdir}
popd

%files
%license LICENSE
%{_libdir}/libcrypto_mb.so.*

%files devel
%dir %{_includedir}/crypto_mb
%{_includedir}/crypto_mb/cpu_features.h
%{_includedir}/crypto_mb/defs.h
%{_includedir}/crypto_mb/ec_nistp256.h
%{_includedir}/crypto_mb/ec_nistp384.h
%{_includedir}/crypto_mb/ec_nistp521.h
%{_includedir}/crypto_mb/ec_sm2.h
%{_includedir}/crypto_mb/ed25519.h
%{_includedir}/crypto_mb/exp.h
%{_includedir}/crypto_mb/rsa.h
%{_includedir}/crypto_mb/sm3.h
%{_includedir}/crypto_mb/sm4.h
%{_includedir}/crypto_mb/status.h
%{_includedir}/crypto_mb/version.h
%{_includedir}/crypto_mb/x25519.h
%{_includedir}/crypto_mb/sm4_ccm.h
%{_includedir}/crypto_mb/sm4_gcm.h
%{_libdir}/libcrypto_mb.so

%files static
%{_libdir}/libcrypto_mb.a

%files doc
%doc README.md DEPRECATION_NOTES.md CHANGELOG.md
%doc CONST_TIME_EXECUTION_TESTING.md SECURITY.md
%doc sources/ippcp/crypto_mb/Readme.md

%changelog
* Mon Feb 27 2023 happy_orange <songnannan@linux.alibaba.com> - 1.0.6-1
- Update to 1.0.6

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 1.0.5-1
- Init package from upstream
